;;; The sort package -- sorted predicates
;;; Olin Shivers 10/98.
;;;
;;; (vector-sorted? < v [start end]) -> boolean

(: vector-sorted?
   (procedure vector #!optional fixnum fixnum -> boolean))
(define (vector-sorted? elt< v . maybe-start+end)
  (assert-type 'vector-sorted? (procedure? elt<))
  (assert-type 'vector-sorted? (vector? v))
  (let-values (((start end)
                (vector-start+end 'vector-sorted? v maybe-start+end)))
    (or (>= start end)                 ; Empty range
        (let lp ((i (the fixnum (+ start 1)))
                 (vi-1 (vector-ref v start)))
          (or (>= i end)
              (let ((vi (vector-ref v i)))
                (and (not (elt< vi vi-1))
                     (lp (+ i 1) vi))))))))

;;; Copyright and porting non-notices
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Give me a break. It's fifteen lines of code. I place this code in the
;;; public domain; help yourself.
